
//////////////////////////////////////////////////////////////////////////////
//
// MArrayD
//
// Array of Double_t. It is almost the same than TArrayD but derives from
// TObject
//
// Another advantage is: operator[] has no range check!
//
//////////////////////////////////////////////////////////////////////////////
#include "MArrayD.h"
#include "TArrayD.h"

ClassImp(MArrayD);

// --------------------------------------------------------------------------
//
//  Cuts the last entries of an array containing only zeros.
//
void MArrayD::StripZeros(TArrayD &arr)
{

  const Int_t n = arr.GetSize();
  
  for (Int_t i=n-1; i>=0; i--)
    if (arr[i] != 0)
        {
          arr.Set(i+1);
          break;
        }
}

// --------------------------------------------------------------------------
//
//  Cuts the last entries of an array containing only zeros.
//
void MArrayD::StripZeros()
{
    const Int_t n = GetSize();

    for (Int_t i=n-1; i>=0; i--)
      if ((*this)[i] != 0)
        {
          Set(i+1);
          break;
        }
}

