//////////////////////////////////////////////////////////////////////////////
//
// MArrayF
//
// Array of Float_t. It is almost the same than TArrayF but derives from
// TObject
//
// Another advantage is: operator[] has no range check!
//
//////////////////////////////////////////////////////////////////////////////
#include "MArrayF.h"
#include "TArrayF.h"

ClassImp(MArrayF);

// --------------------------------------------------------------------------
//
//  Cuts the last entries of an array containing only zeros.
//
void MArrayF::StripZeros(TArrayF &arr)
{

  const Int_t n = arr.GetSize();
  
  for (Int_t i=n-1; i>=0; i--)
    if (arr[i] != 0)
        {
          arr.Set(i+1);
          break;
        }
}

// --------------------------------------------------------------------------
//
//  Cuts the last entries of an array containing only zeros.
//
void MArrayF::StripZeros()
{
    const Int_t n = GetSize();

    for (Int_t i=n-1; i>=0; i--)
      if ((*this)[i] != 0)
        {
          Set(i+1);
          break;
        }
}

