#ifndef MARS_MContinueList
#define MARS_MContinueList

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MContinueList                                                           //
//                                                                         //
// Does nothing than return kCONTINUE in the Process-fucntion              //
// (use with filters)                                                      //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#ifndef MARS_MContinue
#include "MContinue.h"
#endif

#ifndef MARS_MFilterList
#include "MFilterList.h"
#endif

class MLog;
class MFilter;
class MFilterList;
class MTaskList;
class MStatusDisplay;
class MContinue;

class MContinueList : public MContinue
{
private:
    MTaskList   *fTaskList;
    MFilterList *fFilters;
    TEnv        *fEnv;
    // MTask
    //Int_t PreProcess(MParList *list);
    //Int_t Process();
    //Int_t PostProcess();

    // MContinue
    enum { kIsOwner = BIT(14), kFilterIsPrivate = BIT(15), kAllowEmpty = BIT(16) };

public:
    MContinueList(const char *name=NULL, const char *title=NULL);
    MContinueList(MContinueList *contlist);
    ~MContinueList();

    // MContinueList
    Int_t AddToList(MContinue *cont);

    MFilterList *GetFilterList() { return fFilters; }

    //TObject *FindObject(const TObject *obj);
    //TObject *FindObject(const char *name);

    void SetAllowEmpty(Bool_t b=kTRUE) { b ? SetBit(kAllowEmpty) : ResetBit(kAllowEmpty); }
    Bool_t IsAllowEmpty() const { return TestBit(kAllowEmpty); }


    void SetInverted(Bool_t i=kTRUE);
    Bool_t IsInverted() const { return fFilters->IsInverted(); }

    //TObject *Clone() { return MContinue::Clone(); }

    // MParContainer
    //void SetDisplay(MStatusDisplay *d);
    //void SetLogStream(MLog *lg);
    Int_t ReadEnv(const TEnv &env, TString prefix, Bool_t print=kFALSE);

    ClassDef(MContinueList, 1) //Task returning kCONTINUE
};

#endif
