//////////////////////////////////////////////////////////////////////////////
//                                                                          //
// MIter                                                                    //
//                                                                          //
// This is the original MIter, but returns a MParContainer instead of a     //
// TObject.                                                                 //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
#include "MIter.h"

ClassImp(MIter);

//______________________________________________________________________________
MIter::MIter(const MIter &iter)
{
   // Copy a MIter. This involves allocating a new MIterator of the right
   // sub class and assigning it with the original.

   if (iter.fIterator) {
      fIterator = iter.GetCollection()->MakeIterator();
      fIterator->operator=(*iter.fIterator);
   } else
      fIterator = 0;
}

//______________________________________________________________________________
MIter &MIter::operator=(const MIter &rhs)
{
   // Assigning an MIter to another. This involves allocatiing a new MIterator
   // of the right sub class and assigning it with the original.

   if (this != &rhs) {
      if (rhs.fIterator) {
         delete fIterator;
         fIterator = rhs.GetCollection()->MakeIterator();
         fIterator->operator=(*rhs.fIterator);
      }
   }
   return *this;
}
